<?php
/**
 * Consultancy Services functions and definitions
 *
 * @package Consultancy Services
 */

if ( ! defined( 'CONSULTANCY_SERVICES_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'CONSULTANCY_SERVICES_VERSION', '1.0.0' );
}

function consultancy_services_setup() {

	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'consultancy-services' ),
			'social-menu' => esc_html__('Social Menu', 'consultancy-services'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'consultancy_services_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'consultancy_services_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $consultancy_services_content_width
 */
function consultancy_services_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'consultancy_services_content_width', 640 );
}
add_action( 'after_setup_theme', 'consultancy_services_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function consultancy_services_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'consultancy-services' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'consultancy-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'consultancy-services' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'consultancy-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'consultancy-services' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'consultancy-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'consultancy-services' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'consultancy-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'consultancy_services_widgets_init' );


function consultancy_services_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }

/**
 * Enqueue scripts and styles.
 */

function consultancy_services_scripts() {
    // Google Fonts
    $query_args = array(
        'family' => rawurlencode('Sen:wght@200;300;400;500;600;700;800'),
        'display' => 'swap',
    );
    wp_enqueue_style('consultancy-services-google-fonts', add_query_arg($query_args, 'https://fonts.googleapis.com/css'), array(), null);

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-5', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-5/css/all.min.css', array(), '5.15.3');

    // Owl Carousel CSS
    wp_enqueue_style('owl-carousel-style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), wp_get_theme()->get('Version'));

    // Main stylesheet
    wp_enqueue_style('consultancy-services-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

    // Add custom inline styles
    require get_parent_theme_file_path('/custom-style.php');
	wp_add_inline_style('consultancy-services-style', $consultancy_services_custom_css);

    // RTL styles if needed
    if (file_exists(get_stylesheet_directory() . '/rtl.css')) {
        wp_style_add_data('consultancy-services-style', 'rtl', 'replace');
    }

    // Navigation script
    wp_enqueue_script('consultancy-services-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Owl Carousel script
    wp_enqueue_script('owl-carousel-jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Custom script
    wp_enqueue_script('consultancy-services-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Wow script.
	wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/revolution/assets/js/wow.js', array('jquery'),'' ,true );
	// Animate CSS
	wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/revolution/assets/css/animate.css' );

    // Comments reply script
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'consultancy_services_scripts');

if (!function_exists('consultancy_services_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function consultancy_services_related_post($post_id){        
        $consultancy_services_categories = get_the_category($post_id);
        if ($consultancy_services_categories) {
            $consultancy_services_category_ids = array();
            $consultancy_services_category = get_category($consultancy_services_category_ids);
            $consultancy_services_categories = get_the_category($post_id);
            foreach ($consultancy_services_categories as $consultancy_services_category) {
                $consultancy_services_category_ids[] = $consultancy_services_category->term_id;
            }
            $consultancy_services_count = $consultancy_services_category->category_count;
            if ($consultancy_services_count > 1) { ?>

         	<?php
		$consultancy_services_related_post_wrap = absint(get_theme_mod('consultancy_services_enable_related_post', 1));
		if($consultancy_services_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('consultancy_services_related_post_text', __('Related Post', 'consultancy-services'))); ?></h2>
                    <?php
                    $consultancy_services_cat_post_args = array(
                        'category__in' => $consultancy_services_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'consultancy_services_related_post_count', '3' ),
                        'post_status' => 'publish',
                        'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $consultancy_services_featured_query = new WP_Query($consultancy_services_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($consultancy_services_featured_query->have_posts()) :

                        while ($consultancy_services_featured_query->have_posts()) : $consultancy_services_featured_query->the_post();
                            ?>
                            <div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php consultancy_services_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $consultancy_services_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/about1.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $consultancy_services_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        consultancy_services_posted_on();
                                        consultancy_services_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('consultancy_services_related_posts', 'consultancy_services_related_post', 10, 1);

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$consultancy_services_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function consultancy_services_sanitize_checkbox($consultancy_services_checked)
{
    // Boolean check.
    return ((isset($consultancy_services_checked) && true == $consultancy_services_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';


//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function consultancy_services_enqueue_function() {

    /**
    * GET START.
    */
    require get_template_directory() . '/getstarted/consultancy_services_about_page.php';

    /**
    * DEMO IMPORT.
    */
    require get_template_directory() . '/demo-import/consultancy_services_config_file.php';

    define('CONSULTANCY_SERVICES_FREE_SUPPORT',__('https://www.revolutionwp.com/products/consultancy-services','consultancy-services'));
    define('CONSULTANCY_SERVICES_PRO_SUPPORT',__('https://www.revolutionwp.com/support/revolution-wp/','consultancy-services'));
    define('CONSULTANCY_SERVICES_REVIEW',__('https://wordpress.org/support/theme/consultancy-services/reviews/','consultancy-services'));
    define('CONSULTANCY_SERVICES_BUY_NOW',__('https://www.revolutionwp.com/products/consultancy-wordpress-theme','consultancy-services'));
    define('CONSULTANCY_SERVICES_LIVE_DEMO',__('https://demo.revolutionwp.com/consultancy-services-pro/','consultancy-services'));
    define('CONSULTANCY_SERVICES_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/consultancy-services-pro/','consultancy-services'));
    define('CONSULTANCY_SERVICES_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/consultancy-services-free/','consultancy-services'));
    
}
add_action( 'after_setup_theme', 'consultancy_services_enqueue_function' );


/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

function consultancy_services_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'consultancy_services_remove_customize_register', 11 );

/************************************************************************************/

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'consultancy_services_loop_columns');

if (!function_exists('consultancy_services_loop_columns')) {

	function consultancy_services_loop_columns() {

		$consultancy_services_columns = get_theme_mod( 'consultancy_services_per_columns', 3 );

		return $consultancy_services_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'consultancy_services_per_page', 20 );

function consultancy_services_per_page( $consultancy_services_cols ) {

  	$consultancy_services_cols = get_theme_mod( 'consultancy_services_product_per_page', 9 );

	return $consultancy_services_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'consultancy_services_products_args' );

function consultancy_services_products_args( $consultancy_services_args ) {

    $consultancy_services_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $consultancy_services_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $consultancy_services_args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function consultancy_services_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --consultancy_services_logo_width: <?php echo absint(get_theme_mod('consultancy_services_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('consultancy_services_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'consultancy_services_custom_css' );

function consultancy_services_sanitize_choices( $consultancy_services_input, $consultancy_services_setting ) {
    global $wp_customize; 
    $consultancy_services_control = $wp_customize->get_control( $consultancy_services_setting->id ); 
    if ( array_key_exists( $consultancy_services_input, $consultancy_services_control->choices ) ) {
        return $consultancy_services_input;
    } else {
        return $consultancy_services_setting->default;
    }
}

//Excerpt 
function consultancy_services_excerpt_function($consultancy_services_excerpt_count = 35) {
    $consultancy_services_excerpt = get_the_excerpt();
    $consultancy_services_text_excerpt = wp_strip_all_tags($consultancy_services_excerpt);
    $consultancy_services_excerpt_limit = (int) get_theme_mod('consultancy_services_excerpt_limit', $consultancy_services_excerpt_count);
    $consultancy_services_words = preg_split('/\s+/', $consultancy_services_text_excerpt); 
    $consultancy_services_trimmed_words = array_slice($consultancy_services_words, 0, $consultancy_services_excerpt_limit);
    $consultancy_services_theme_excerpt = implode(' ', $consultancy_services_trimmed_words);

    return $consultancy_services_theme_excerpt;
}



// Add admin notice
function consultancy_services_admin_notice() { 
    global $pagenow;
    $consultancy_services_theme_args      = wp_get_theme();
    $consultancy_services_meta            = get_option( 'consultancy_services_admin_notice' );
    $name            = $consultancy_services_theme_args->__get( 'Name' );
    $consultancy_services_current_screen  = get_current_screen();

    if( !$consultancy_services_meta ){
        if( is_network_admin() ){
            return;
        }

        if( ! current_user_can( 'manage_options' ) ){
            return;
        } 
        
        if( $consultancy_services_current_screen->base !== 'appearance_page_consultancy_services_guide' && 
            $consultancy_services_current_screen->base !== 'toplevel_page_consultancyservices-demoimport' ) { ?>

            <div class="notice notice-success consultancy-services-welcome-notice">
                <p class="consultancy-services-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'consultancy_services_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'consultancy-services' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="consultancy-services-welcome-notice-wrap">
                    <h2 class="consultancy-services-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $consultancy_services_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'consultancy-services' ), $consultancy_services_theme_name ) );
                        ?>
                    </h2>
                    <p class="consultancy-services-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'consultancy-services' ); ?>
                    </p>

                    <div class="consultancy-services-welcome-info">
                        <div class="consultancy-services-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'consultancy-services' ); ?>">
                        </div>

                        <div class="consultancy-services-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'consultancy-services' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'consultancy-services' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=consultancyservices-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'consultancy-services' ); ?></a></p>
                        </div>

                        <div class="consultancy-services-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'consultancy-services' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'consultancy-services' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=consultancy-services-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'consultancy-services' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

    }
}

add_action( 'admin_notices', 'consultancy_services_admin_notice' );

if( ! function_exists( 'consultancy_services_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function consultancy_services_update_admin_notice(){
    if ( isset( $_GET['consultancy_services_admin_notice'] ) && $_GET['consultancy_services_admin_notice'] = '1' ) {
        update_option( 'consultancy_services_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'consultancy_services_update_admin_notice' );

add_action('after_switch_theme', 'consultancy_services_setup_options');
function consultancy_services_setup_options () {
    update_option('consultancy_services_admin_notice', FALSE );
}

// changelog
function consultancy_services_get_changelog_from_readme() {
    $consultancy_services_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($consultancy_services_file_path)) {
        $consultancy_services_content = file_get_contents($consultancy_services_file_path);

        // Extract changelog section
        $consultancy_services_changelog_start = strpos($consultancy_services_content, "== Changelog ==");
        $consultancy_services_changelog = substr($consultancy_services_content, $consultancy_services_changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $consultancy_services_changelog, $consultancy_services_matches, PREG_SET_ORDER);
        
        return $consultancy_services_matches;
    }
    return [];
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );